<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Dashboard</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Ionicons -->
  <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
  <!-- iCheck -->
  <link rel="stylesheet" href="plugins/icheck-bootstrap/icheck-bootstrap.min.css">
  <!-- JQVMap -->
  <link rel="stylesheet" href="plugins/jqvmap/jqvmap.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- overlayScrollbars -->
  <link rel="stylesheet" href="plugins/overlayScrollbars/css/OverlayScrollbars.min.css">
  <!-- Daterange picker -->
  <link rel="stylesheet" href="plugins/daterangepicker/daterangepicker.css">
  <!-- summernote -->
  <link rel="stylesheet" href="plugins/summernote/summernote-bs4.min.css">
  <!-- Select2 -->
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- Nhúng các thư viện jQuery -->
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <!-- <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script> -->
  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body onload="onPageLoading()" class="hold-transition sidebar-mini layout-fixed">
  <div class="wrapper">

    <!-- Preloader -->
    <div class="preloader flex-column justify-content-center align-items-center">
      <img class="animation__shake" src="dist/img/AdminLTELogo.png" alt="AdminLTELogo" height="60" width="60">
    </div>

    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Quản lý bảng điểm</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="control-sidebar" data-controlsidebar-slide="true" href="#" role="button">
            <i class="fas fa-th-large"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">AdminLTE 3</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Trịnh Thế</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <li class="nav-item">
              <a href="gradelist.html" class="nav-link active">
                <i class="nav-icon fas fa-th"></i>
                <p>
                  Quản lý bảng điểm
                  <span class="right badge badge-danger">Hot</span>
                </p>
              </a>
            </li>
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="./index.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v1</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="./index2.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="./index3.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v3</p>
                  </a>
                </li>
              </ul>
            </li>

            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-tree"></i>
                <p>
                  UI Elements
                  <i class="fas fa-angle-left right"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="pages/UI/general.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>General</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="pages/UI/icons.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Icons</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="pages/UI/buttons.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Buttons</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="pages/UI/sliders.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Sliders</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="pages/UI/modals.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Modals & Alerts</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="pages/UI/navbar.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Navbar & Tabs</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="pages/UI/timeline.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Timeline</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="pages/UI/ribbons.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Ribbons</p>
                  </a>
                </li>
              </ul>
            </li>

          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Quản lý bảng điểm</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Bảng điểm</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <div class="jumbotron form-group">
            <div class="form-group">
              <h4><b>Lọc bảng điểm</b></h4>
            </div>
            <div class="row form-group">
              <div class="col-sm-5">
                <div class="row">
                  <div class="col-sm-3">
                    <label for="sinhvien">Sinh viên</label>
                  </div>
                  <div class="col-sm-8 form-group">
                    <select class="form-control select2bs4" name="" id="select-student" style="width: 100%;">
                      <option selected="selected" value="none"> ==Chọn sinh viên ==</option>
                    </select>
                  </div>
                </div>
              </div>
              <div class="col-sm-5">
                <div class="row">
                  <div class="col-sm-3 form-group">
                    <label for="monhoc">Môn học</label>
                  </div>
                  <div class="col-sm-9">
                    <select class="form-control select2bs4" name="" id="select-subject" style="width: 100%;">
                      <option value="none">== Chọn môn học ==</option>
                    </select>
                  </div>
                </div>
              </div>
              <div class="col-sm-2">
                <button id="btn-filter-grade" class="btn btn-primary">Lọc dữ liệu</button>
              </div>
            </div>
          </div>
          <div class="form-group">
            <button id="btn-add-grade" class="btn btn-primary w-15">Thêm Grade</button>
          </div>
          <div class="form-group">
            <table id="grade-table" class="table table-hover table-striped table-bordered">
              <thead class="table table-primary">
                <th>STT</th>
                <th>Sinh viên</th>
                <th>Môn học</th>
                <th>Điểm</th>
                <th>Ngày thi</th>
                <th>Action</th>
              </thead>
            </table>
          </div>
          <!-- Modal Create Grade -->
          <div id="add-grade-modal" class="modal" tabindex="-1" role="dialog">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title">Thêm grade</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="">Sinh viên</label>
                    </div>
                    <div class="col-sm-8">
                      <select class="select2bs4 form-control" name="" id="select-student-add-modal">
                        <option value="none"> == Chọn sinh viên == </option>
                      </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="">Môn học</label>
                    </div>
                    <div class="col-sm-8">
                      <select class="select2bs4 form-control" name="" id="select-subject-add-modal">
                        <option value="none"> == Chọn môn học == </option>
                      </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="">Điểm</label>
                    </div>
                    <div class="col-sm-8">
                      <input class="form-control" type="text" name="" id="inp-grade-add-modal">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="">Ngày thi</label>
                    </div>
                    <div class="col-sm-8">
                      <div class="input-group date" id="reservationdate-add-modal" data-target-input="nearest">
                        <input id="inp-exam-date-add-modal" type="text" class="form-control datetimepicker-input" data-target="#reservationdate-add-modal"/>
                        <div class="input-group-append" data-target="#reservationdate-add-modal" data-toggle="datetimepicker">
                            <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                  <button id="btn-confirm-add-grade" type="button" class="btn btn-primary">Xác nhận</button>
                </div>
              </div>
            </div>
          </div>
          <!-- Modal Edit Grade -->
          <div id="edit-grade-modal" class="modal" tabindex="-1" role="dialog">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title">Edit Grade</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="">Sinh viên</label>
                    </div>
                    <div class="col-sm-8">
                      <select class="select2bs4 form-control" name="" id="select-student-edit-modal">
                        <option value="none"> == Chọn sinh viên == </option>
                      </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="">Môn học</label>
                    </div>
                    <div class="col-sm-8">
                      <select class="select2bs4 form-control" name="" id="select-subject-edit-modal">
                        <option value="none"> == Chọn môn học == </option>
                      </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="">Điểm</label>
                    </div>
                    <div class="col-sm-8">
                      <input class="form-control" type="text" name="" id="inp-grade-edit-modal">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="">Ngày thi</label>
                    </div>
                    <div class="col-sm-8">
                      <div class="input-group date" id="reservationdate-edit-modal" data-target-input="nearest">
                        <input id="inp-exam-date-edit-modal" type="text" class="form-control datetimepicker-input" data-date-format="dd/mm/yyyy" data-target="#reservationdate-edit-modal"/>
                        <div class="input-group-append" data-target="#reservationdate-edit-modal" data-toggle="datetimepicker">
                            <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                  <button id="btn-confirm-edit-grade" type="button" class="btn btn-primary">Xác nhận</button>
                </div>
              </div>
            </div>
          </div>
          <!-- Modal Delete Grade -->
          <div id="delete-grade-modal" class="modal" tabindex="-1" role="dialog">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title">Xóa Grade</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <p class="modal-text">Bạn chắc chắn muốn xóa Grade này</p>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                  <button id="btn-confirm-delete-grade" type="button" class="btn btn-danger">Xác nhận</button>
                </div>
              </div>
            </div>
          </div>
          <script>
            var gAllGrade = "";
            var gStudentList = "";
            var gSubjectList = "";
            const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
            var gNameCol = ["id", "studentId", "subjectId", "grade", "examDate", "action"];
            const gSTT_COL = 0;
            const gSTUDENT_COL = 1;
            const gSUBJECT_COL = 2;
            const gGRADE_COL = 3;
            const gEXAM_DATE_COL = 4;
            const gACTION_COL = 5;
            var gSTT = 0;
            var gGradeId = "";
            //Định nghĩa bảng
            var gGradeTable = $("#grade-table").DataTable({
              columns: [
                { data: gNameCol[gSTT_COL] },
                { data: gNameCol[gSTUDENT_COL] },
                { data: gNameCol[gSUBJECT_COL] },
                { data: gNameCol[gGRADE_COL] },
                { data: gNameCol[gEXAM_DATE_COL] },
                { data: gNameCol[gACTION_COL] },
              ],
              columnDefs: [
                {
                  targets: gSTT_COL,
                  render: function (data) {
                    gSTT++;
                    return gSTT;
                  }
                },
                {
                  targets: gSTUDENT_COL,
                  render: function (data) {
                    var vStudentName = getNameStudent(data);
                    return vStudentName;
                  }
                },
                {
                  targets: gSUBJECT_COL,
                  render: function (data) {
                    var vSubjectName = getNameSubject(data);
                    return vSubjectName;
                  }
                },
                {
                  targets: gACTION_COL,
                  defaultContent: `
                        <i title='edit' class='far fa-edit fa-lg' style = 'color:green; cursor:pointer;'></i>
                        <i title='delete' class='fas fa-trash fa-lg' style = 'color:red; cursor:pointer;'></i>
                        `
                }
              ],
              autoWidth: false
            });
            $("#btn-add-grade").on("click", function () {// nút thêm grade
              $("#add-grade-modal").modal("show");
            })
            $("#btn-confirm-add-grade").on("click", function () {// nút xác nhận thêm grade
              onBtnConfirmAddGradeClick();
            });
            $("#grade-table").on("click", ".fa-edit", function () {// nút edit grade
              onBtnEditGradeClick(this);
            });
            $("#btn-confirm-edit-grade").on("click", function () {// nút xác nhận edit grade
              onBtnConfirmEditGradeClick();
            });
            $("#grade-table").on("click", ".fa-trash", function () {// nút xóa grade
              onBtnDeleteGradeClick(this);
            });
            $("#btn-confirm-delete-grade").on("click", function () {// nút xác nhận xóa grade
              onBtnConfirmDeleteGradeClick();
            });
            $("#btn-filter-grade").on("click", function () {// nút xác nhận xóa grade
              onBtnFilterGradeClick();
            });
            //Hàm tải trang
            function onPageLoading() {
              "use strict";
              console.log("Trang được tải")
              callAjaxStudentList();
              loadStudentToSelect(gStudentList);
              callAjaxSubjectList();
              loadSubjectToSelect(gSubjectList);
              getAllGradeList();
              loadAllGradeToTable(gAllGrade);
            };
            //Hàm xử lý lọc dữ liệu
            function onBtnFilterGradeClick(){
              var vFilterObj = {
                studentId: "",
                subjectId: "",
              }
              getFilterData(vFilterObj);
              var vFilterGradeData = filterGrade(vFilterObj);
              gSTT = 0;
              loadAllGradeToTable(vFilterGradeData);
            };
            //Hàm xư lý nút Xác nhận Edit Grade
            function onBtnConfirmDeleteGradeClick() {
              callAjaxDeleteGrade();
              $("#delete-grade-modal").modal("hide");
              gSTT = 0;
              getAllGradeList();
              loadAllGradeToTable(gAllGrade);
            }
            //Hàm xư lý nút Edit Grade
            function onBtnDeleteGradeClick(paramButton) {
              "use strict";
              console.log("Nút Delete được ấn")
              var vRowClick = $(paramButton).closest("tr");
              var vGradeData = gGradeTable.row(vRowClick).data();
              console.log(vGradeData);
              gGradeId = vGradeData.id;
              $("#delete-grade-modal").modal("show");
            }
            //Hàm xư lý nút Xác nhận Edit Grade
            function onBtnConfirmEditGradeClick() {
              "use strict";
              var vGradeObject = {
                studentId: "",
                subjectId: "",
                grade: "",
                examDate: "",
              }
              getGradeByEditModalForm(vGradeObject);
              console.log(vGradeObject);
              var vCheck = validateGradeObject(vGradeObject);
              if (vCheck == true) {
                callAjaxEditGrade(vGradeObject);
                $("#edit-grade-modal").modal("hide");
                gSTT = 0;
                getAllGradeList();
                loadAllGradeToTable(gAllGrade);
              }
            }
            //Hàm xư lý nút Edit Grade
            function onBtnEditGradeClick(paramButton) {
              "use strict";
              console.log("Nút Edit được ấn")
              var vRowClick = $(paramButton).closest("tr");
              var vGradeData = gGradeTable.row(vRowClick).data();
              console.log(vGradeData);
              gGradeId = vGradeData.id;
              $("#edit-grade-modal").modal("show");
              loadGradeEditModal(vGradeData);
            }
            //Hàm xư lý nút Xác nhận Add Grade
            function onBtnConfirmAddGradeClick() {
              "use strict";
              var vGradeObject = {
                studentId: "",
                subjectId: "",
                grade: "",
                examDate: "",
              }
              getGradeByAddModalForm(vGradeObject);
              console.log(vGradeObject);
              var vCheck = validateGradeObject(vGradeObject);
              if (vCheck == true) {
                callAjaxAddGrade(vGradeObject);
                $("#add-grade-modal").modal("hide");
                restAddModal();
                gSTT = 0;
                getAllGradeList();
                loadAllGradeToTable(gAllGrade);
              }
            };
            //Hàm reset modal add grade
            function restAddModal(){
              $("#add-grade-modal").find("input").each(function(){
                $(this).val("");
              });
              $("#add-grade-modal").find("select").each(function(){
                $(this).val("none").change();
              });
            }
            //Hàm lọc dữ liệu
            function filterGrade(paramFilterObj){
              var vFilterData = gAllGrade.filter(function(grade){
                return (
                  (grade.studentId == paramFilterObj.studentId || paramFilterObj.studentId == "none")&&
        
                  (grade.subjectId == paramFilterObj.subjectId || paramFilterObj.subjectId == "none")
                ) 
              })
              return vFilterData;
            }
            //Hàm truy xuất dữ liệu Filter Grade
            function getFilterData(paramFilterObj){
              paramFilterObj.studentId = $("#select-student").val();
              paramFilterObj.subjectId = $("#select-subject").val();
            }
            //Hàm yêu cầu delete Grade
            function callAjaxDeleteGrade() {
              $.ajax({
                url: gBASE_URL + "/grades/" + gGradeId,
                type: "DELETE",
                contentType: "application/json",
                async: false,
                success: function (response) {
                  console.log(response);
                  alert("Điểm đã được xóa thành công!!!")
                },
                error: function (context) {
                  alert("Xóa điểm thất bại: " + context.responseText);
                }
              })
            }
            //Hàm yêu cầu update Grade
            function callAjaxEditGrade(paramGradeObject) {
              $.ajax({
                url: gBASE_URL + "/grades/" + gGradeId,
                type: "PUT",
                contentType: "application/json",
                data: JSON.stringify(paramGradeObject),
                async: false,
                success: function (response) {
                  console.log(response);
                  alert("Điểm đã được sửa thành công!!!")
                },
                error: function (context) {
                  alert("Điểm sửa thất bại: " + context.responseText);
                }
              })
            }
            //Hàm truy xuất dữ liệu từ modal edit grade
            function getGradeByEditModalForm(paramGradeObj) {
              paramGradeObj.studentId = $("#select-student-edit-modal").val();
              paramGradeObj.subjectId = $("#select-subject-edit-modal").val();
              paramGradeObj.grade = $("#inp-grade-edit-modal").val();
              paramGradeObj.examDate = $("#inp-exam-date-edit-modal").val();
            }
            //Hàm load dữ liệu form modal edit
            function loadGradeEditModal(paramGradeObj) {
              $("#select-student-edit-modal").val(paramGradeObj.studentId).change();
              $("#select-subject-edit-modal").val(paramGradeObj.subjectId).change();
              $("#inp-grade-edit-modal").val(paramGradeObj.grade);
              $("#inp-exam-date-edit-modal").val(paramGradeObj.examDate);
            }
            //Hàm kiêm tra dữ liệu nhập vào modal add grade và edit grade
            function validateGradeObject(paramGradeObject) {
              "use strict";
              var vReSult = true;
              const vREGEX_DATE = /^[0-9]{1,2}\/[0-9]{1,2}\/[0-9]{4}$/;
              if (paramGradeObject.studentId == "none") {
                alert("Sinh viên chưa được chọn");
                vReSult = false;
              }
              else if (paramGradeObject.subjectId == "none") {
                alert("Môn học chưa được chọn");
                vReSult = false;
              }
              else if (paramGradeObject.grade == "") {
                alert("Điểm chưa được nhập");
                vReSult = false;
              }
              else if (isNaN(paramGradeObject.grade)) {
                alert("Điểm phải là 1 số");
                vReSult = false;
              }
              else if (paramGradeObject.grade < 0 || paramGradeObject.grade > 10) {
                alert("Điểm môn học phải >=0 và <10");
                vReSult = false;
              }
              else if (paramGradeObject.examDate == "") {
                alert("Ngày thi chưa được nhập");
                vReSult = false;
              }
              else if (vREGEX_DATE.test(paramGradeObject.examDate) == false) {
                alert("Ngày thi không đúng định dạng");
                vReSult = false;
              }
              return vReSult;
            }
            //Hàm kiểm tra id sinh viên
            //Hàm yêu cầu tạo grade
            function callAjaxAddGrade(paramGradeObject) {
              $.ajax({
                url: gBASE_URL + "/grades",
                type: "POST",
                contentType: "application/json",
                data: JSON.stringify(paramGradeObject),
                async: false,
                success: function (response) {
                  console.log(response);
                  alert("Điểm đã được thêm thành công!!!")
                },
                error: function (context) {
                  alert("Điểm thêm vào thất bại: " + context.responseText);
                }
              })
            }
            //Hàm truy xuất dữ liệu từ modal
            function getGradeByAddModalForm(paramGradeObject) {
              paramGradeObject.studentId = $("#select-student-add-modal").val();
              paramGradeObject.subjectId = $("#select-subject-add-modal").val();
              paramGradeObject.grade = $("#inp-grade-add-modal").val();
              paramGradeObject.examDate = $("#inp-exam-date-add-modal").val();
            }
            //Hàm lấy tên môn học 
            function getNameSubject(paramSubjectId) {
              var vReSult = "";
              for (var bI = 0; bI < gSubjectList.length; bI++) {
                if (gSubjectList[bI].id == paramSubjectId) {
                  vReSult = gSubjectList[bI].subjectName;
                }
              }
              return vReSult;
            }
            //Hàm lấy tên học sinh 
            function getNameStudent(paramStudentId) {
              var vReSult = "";
              for (var bI = 0; bI < gStudentList.length; bI++) {
                if (gStudentList[bI].id == paramStudentId) {
                  vReSult = gStudentList[bI].firstname + " " + gStudentList[bI].lastname;
                }
              }
              return vReSult;
            }
            //Hàm load môn học vào select
            function loadSubjectToSelect(paramSubjectList) {
              "use strict";
              for (var bI = 0; bI < paramSubjectList.length; bI++) {
                $("#select-subject").append($("<option>", {
                  value: paramSubjectList[bI].id,
                  text: paramSubjectList[bI].subjectName
                }))
              }
              for (var bI = 0; bI < paramSubjectList.length; bI++) {
                $("#select-subject-add-modal").append($("<option>", {
                  value: paramSubjectList[bI].id,
                  text: paramSubjectList[bI].subjectName
                }))
              }
              for (var bI = 0; bI < paramSubjectList.length; bI++) {
                $("#select-subject-edit-modal").append($("<option>", {
                  value: paramSubjectList[bI].id,
                  text: paramSubjectList[bI].subjectName
                }))
              }
            }
            //Hàm yêu cầu danh sách môn học
            function callAjaxSubjectList() {
              $.ajax({
                url: gBASE_URL + "/subjects",
                type: "GET",
                dataType: "json",
                async: false,
                success: function (response) {
                  gSubjectList = response;
                  console.log(gSubjectList);
                },
                error: function (context) {
                  alert(context.responseText);
                }
              })
            }
            //Hàm load Student vào select
            function loadStudentToSelect(paramStudentList) {
              "use strict";
              for (var bI = 0; bI < paramStudentList.length; bI++) {
                $("#select-student").append($("<option>", {
                  value: paramStudentList[bI].id,
                  text: paramStudentList[bI].firstname + " " + paramStudentList[bI].lastname
                }))
              }
              for (var bI = 0; bI < paramStudentList.length; bI++) {
                $("#select-student-add-modal").append($("<option>", {
                  value: paramStudentList[bI].id,
                  text: paramStudentList[bI].firstname + " " + paramStudentList[bI].lastname
                }))
              }
              for (var bI = 0; bI < paramStudentList.length; bI++) {
                $("#select-student-edit-modal").append($("<option>", {
                  value: paramStudentList[bI].id,
                  text: paramStudentList[bI].firstname + " " + paramStudentList[bI].lastname
                }))
              }
            }
            //Hàm yêu cầu danh sách sinh viên
            function callAjaxStudentList() {
              $.ajax({
                url: gBASE_URL + "/students",
                type: "GET",
                dataType: "json",
                async: false,
                success: function (response) {
                  gStudentList = response;
                  console.log(gStudentList);
                },
                error: function (context) {
                  alert(context.responseText);
                }
              })
            }
            //Hàm xử lý load bảng điểm
            function loadAllGradeToTable(paramAllGrade) {
              "use strict";
              gGradeTable.clear();
              gGradeTable.rows.add(paramAllGrade);
              gGradeTable.draw();
            }
            //Hàm yêu cầu lấy danh sách bảng điểm
            function getAllGradeList() {
              "use strict";
              $.ajax({
                url: gBASE_URL + "/grades",
                type: "GET",
                dataType: "json",
                async: false,
                success: function (response) {
                  gAllGrade = response;
                  console.log(gAllGrade);
                },
                error: function (context) {
                  alert(context.responseText);
                }
              });
            }
          </script>
        </div><!-- /.container-fluid -->
      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->
    <footer class="main-footer">
      <strong>Copyright &copy; 2022 <a href="https://adminlte.io">TrinhThe</a>.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 3.2.0
      </div>
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- jQuery UI 1.11.4 -->
  <script src="plugins/jquery-ui/jquery-ui.min.js"></script>
  <!-- Resolve conflict in jQuery UI tooltip with Bootstrap tooltip -->
  <script>
    $.widget.bridge('uibutton', $.ui.button)
  </script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- ChartJS -->
  <script src="plugins/chart.js/Chart.min.js"></script>
  <!-- Sparkline -->
  <script src="plugins/sparklines/sparkline.js"></script>
  <!-- JQVMap -->
  <script src="plugins/jqvmap/jquery.vmap.min.js"></script>
  <script src="plugins/jqvmap/maps/jquery.vmap.usa.js"></script>
  <!-- jQuery Knob Chart -->
  <script src="plugins/jquery-knob/jquery.knob.min.js"></script>
  <!-- daterangepicker -->
  <script src="plugins/moment/moment.min.js"></script>
  <script src="plugins/daterangepicker/daterangepicker.js"></script>
  <!-- Tempusdominus Bootstrap 4 -->
  <script src="plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
  <!-- Summernote -->
  <script src="plugins/summernote/summernote-bs4.min.js"></script>
  <!-- overlayScrollbars -->
  <script src="plugins/overlayScrollbars/js/jquery.overlayScrollbars.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <!-- AdminLTE for demo purposes -->
  <!-- <script src="dist/js/demo.js"></script> -->
  <!-- AdminLTE dashboard demo (This is only for demo purposes) -->
  <script src="dist/js/pages/dashboard.js"></script>
  <!-- Select2 -->
  <script src="plugins/select2/js/select2.full.min.js"></script>
  <script>
    $(function () {
      //Initialize Select2 Elements
      $('.select2').select2()

      //Initialize Select2 Elements
      $('.select2bs4').select2({
        theme: 'bootstrap4'
      })
      //Date picker
      $('#reservationdate-add-modal').datetimepicker({
        format: "DD/MM/YYYY",
      });
      $('#reservationdate-edit-modal').datetimepicker({
        format: "DD/MM/YYYY",
      });
    });
  </script>
</body>

</html>